      ******************************************************************
      **                                                              **
      **                  WebSphere MQ for Windows                    **
      **                                                              **
      **  FILE NAME:      CMQDLHL                                     **
      **                                                              **
      **  DESCRIPTION:    Dead Letter Header Structure                **
      **                                                              **
      ******************************************************************
      **  <START_COPYRIGHT>                                           **
      **  Licensed Materials - Property of IBM                        **
      **                                                              **
      **  5724-B41                                                    **
      **  (C) Copyright IBM Corp. 1993, 2002 All Rights Reserved.     **
      **                                                              **
      **  US Government Users Restricted Rights - Use, duplication or **
      **  disclosure restricted by GSA ADP Schedule Contract with     **
      **  IBM Corp.                                                   **
      **  <END_COPYRIGHT>                                             **
      ******************************************************************
      **                                                              **
      **  FUNCTION:       This file declares the structure MQDLH,     **
      **                  which is used by the main MQI.              **
      **                                                              **
      **  PROCESSOR:      COBOL                                       **
      **                                                              **
      ******************************************************************
 
      **   MQDLH structure
        10 MQDLH.
      **    Structure identifier
         15 MQDLH-STRUCID        PIC X(4).
      **    Structure version number
         15 MQDLH-VERSION        PIC S9(9) BINARY.
      **    Reason message arrived on dead-letter (undelivered-message)
      **    queue
         15 MQDLH-REASON         PIC S9(9) BINARY.
      **    Name of original destination queue
         15 MQDLH-DESTQNAME      PIC X(48).
      **    Name of original destination queue manager
         15 MQDLH-DESTQMGRNAME   PIC X(48).
      **    Numeric encoding of data that follows MQDLH
         15 MQDLH-ENCODING       PIC S9(9) BINARY.
      **    Character set identifier of data that follows MQDLH
         15 MQDLH-CODEDCHARSETID PIC S9(9) BINARY.
      **    Format name of data that follows MQDLH
         15 MQDLH-FORMAT         PIC X(8).
      **    Type of application that put message on dead-letter
      **    (undelivered-message) queue
         15 MQDLH-PUTAPPLTYPE    PIC S9(9) BINARY.
      **    Name of application that put message on dead-letter
      **    (undelivered-message) queue
         15 MQDLH-PUTAPPLNAME    PIC X(28).
      **    Date when message was put on dead-letter
      **    (undelivered-message) queue
         15 MQDLH-PUTDATE        PIC X(8).
      **    Time when message was put on the dead-letter
      **    (undelivered-message) queue
         15 MQDLH-PUTTIME        PIC X(8).
 
      ******************************************************************
      **  End of CMQDLHL                                              **
      ******************************************************************
